'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = combineForms;

var _modeledEnhancer = require('../enhancers/modeled-enhancer');

var _modeledEnhancer2 = _interopRequireDefault(_modeledEnhancer);

var _modelReducer = require('./model-reducer');

var _modelReducer2 = _interopRequireDefault(_modelReducer);

var _formReducer = require('./form-reducer');

var _formReducer2 = _interopRequireDefault(_formReducer);

var _redux = require('redux');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var NULL_ACTION = { type: null };

var defaults = {
  key: 'forms',
  plugins: []
};

function getSubModelString(model, subModel) {
  if (!model) return subModel;

  return model + '.' + subModel;
}

function combineForms(forms) {
  var model = arguments.length <= 1 || arguments[1] === undefined ? '' : arguments[1];
  var options = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];

  var formKeys = Object.keys(forms);
  var modelReducers = {};
  var initialFormState = {};
  var optionsWithDefaults = _extends({}, defaults, options);
  var key = optionsWithDefaults.key;
  var plugins = optionsWithDefaults.plugins;


  formKeys.forEach(function (formKey) {
    var formValue = forms[formKey];
    var subModel = getSubModelString(model, formKey);

    if (typeof formValue === 'function') {
      var initialState = void 0;
      try {
        initialState = formValue(undefined, NULL_ACTION);
      } catch (error) {
        initialState = null;
      }

      modelReducers[formKey] = (0, _modeledEnhancer2.default)(formValue, subModel);
      initialFormState[formKey] = initialState;
    } else {
      modelReducers[formKey] = (0, _modelReducer2.default)(subModel, formValue);
      initialFormState[formKey] = formValue;
    }
  });

  return (0, _redux.combineReducers)(_extends({}, modelReducers, _defineProperty({}, key, (0, _formReducer2.default)(model, initialFormState, { plugins: plugins }))));
}