'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = getFieldFromState;

var _get = require('./get');

var _get2 = _interopRequireDefault(_get);

var _toPath = require('./to-path');

var _toPath2 = _interopRequireDefault(_toPath);

var _formReducer = require('../reducers/form-reducer');

var _getForm = require('./get-form');

var _getForm2 = _interopRequireDefault(_getForm);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getFieldFromState(state, modelString) {
  var form = (0, _getForm2.default)(state, modelString);

  if (!form) return null;

  if (!modelString.length) return form;

  var formPath = (0, _toPath2.default)(form.$form.model);
  var fieldPath = (0, _toPath2.default)(modelString).slice(formPath.length);

  var field = (0, _get2.default)(form, fieldPath, _formReducer.initialFieldState);

  if (field && '$form' in field) return field.$form;

  if (!field) return _formReducer.initialFieldState;

  return field;
}